﻿using GcDevicePc.IniParam;
using Modbus.Data;
using Modbus.Device;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace GcDevicePc.Common
{
    class NModbusSlave
    {
       private ModbusSlave slave;

        public NModbusSlave()
        {
            listener = new TcpListener(IPAddress.Any, 502);// 端口根据需要确定
            listener.Start();

            slave = ModbusTcpSlave.CreateTcp(1, listener);

            slave.DataStore = DataStoreFactory.CreateDefaultDataStore();

            slave.DataStore.DataStoreWrittenTo += new EventHandler<DataStoreEventArgs>(Modbus_DataStoreWriteTo);

            slave.ModbusSlaveRequestReceived += new EventHandler<ModbusSlaveRequestEventArgs>(Modbus_Request_Event);

            slave.DataStore.DataStoreReadFrom += new EventHandler<DataStoreEventArgs>(DataStore_DataStoreReadFrom);

            slave.DataStore.DataStoreWrittenTo += new EventHandler<DataStoreEventArgs>(DataStore_DataStoreWrittenTo);

            slave.Listen();

        }

        public void NModbusSlaveClose()
        {

        }

        ~NModbusSlave()
        {
            listener.Stop();
            slave.Dispose();
        }

        private readonly TcpListener listener;
        // 网络流列表
        //private List<NetworkStream> streams = new List<NetworkStream>();

        private void DataStore_DataStoreWrittenTo(object sender, DataStoreEventArgs e)
        {
        }

        private void DataStore_DataStoreReadFrom(object sender, DataStoreEventArgs e)
        {
            
            try
            {

                switch (e.ModbusDataType)
                {
                    case ModbusDataType.HoldingRegister:
                        for (int i = 0; i < e.Data.B.Count; i++)
                        {
                            slave.DataStore.HoldingRegisters[e.StartAddress + i + 1] = slavereadhreg(Convert.ToUInt16(e.StartAddress + i + 1)); 
                           
                        }
                        break;
                    case ModbusDataType.Coil:
                        for (int i = 0; i < e.Data.A.Count; i++)
                        {
                            slave.DataStore.CoilDiscretes[e.StartAddress + i + 1] = slavereadcreg(Convert.ToUInt16(e.StartAddress + i + 1)) == 0 ? false : true;
                            
                        }
                        break;
                }
            }
            catch
            {


            }

        }


        private void Modbus_DataStoreWriteTo(object sender, DataStoreEventArgs e)
        {
            try
            {

                switch (e.ModbusDataType)
                {
                    case ModbusDataType.HoldingRegister:
                        slavewirtehreg(e.StartAddress, e.Data.B[e.StartAddress]);
                        break;
                    case ModbusDataType.Coil:

                        break;
                }
            }
            catch
            {

            }
        }

        //trigger Modbus_Request_Event
        private void Modbus_Request_Event(object sender, ModbusSlaveRequestEventArgs e)
        {


        }

        static ushort slavereadhreg(ushort address)
        {
            try
            {
                ushort value = 0;
                ushort signalddress = 17;
                ushort baseaddress = 23;
                address = (ushort)(address - 1);
                int listnum = SharedSpace.Data.listValue.Count;
                if (address >= 17)
                {
                    ushort[] s = new ushort[2];
                    float[] f = new float[2];

                    if (address >= 17 && address <= 22)   //信号输出
                    {
                        if (address == 17 || address == 18)
                            f[0] = float.Parse(globaldata.m_dpbuffer.ShowList.showDet.fDetValue.ToString("0.000"));
                        if (address == 19 || address == 20)
                            f[0] = float.Parse(globaldata.m_dpbuffer.ShowList.showDet.iDetValue.ToString("0.000"));
                        if (address == 21 || address == 22)
                            f[0] = float.Parse(globaldata.m_dpbuffer.ShowList.showDet.bDetValue.ToString("0.000"));
                        Buffer.BlockCopy(f, 2, s, 0, 2);
                        Buffer.BlockCopy(f, 0, s, 2, 2);
                        value = s[(address - signalddress) % 2];
                    }
                    else if (address >= 23 && listnum > 0)  //组分输出
                    {
                        int readnum = (address - baseaddress) / 2;
                        if (readnum <= listnum - 1)
                        {
                            f[0] = float.Parse(SharedSpace.Data.listValue[readnum].vale.ToString());
                            Buffer.BlockCopy(f, 2, s, 0, 2);
                            Buffer.BlockCopy(f, 0, s, 2, 2);
                            value = s[(address - baseaddress) % 2];
                            //value = address;
                        }
                        else
                        {
                            value = 0;
                        }
                    }
                    else
                    {
                        value = 0;
                    }
                }
                //分析仪状态
                if (address >= 1 && address < 20)
                {
                    switch (address)
                    {
                        case 1:   //进度
                            {
                                if ((ushort)SharedSpace.Data.typesint == 1 || (ushort)SharedSpace.Data.typesint == 2)
                                {
                                    if (SharedSpace.MControl.dateend != 0 && SharedSpace.MControl.zhouqi != 0)
                                    {
                                        value = (ushort)((globaldata.m_hmibuffer.gcinfo.batruncount * 1.0f) /
                                                          (ushort)(SharedSpace.MControl.dateend * 1.0f /
                                                                    SharedSpace.MControl.zhouqi) * 1000);
                                    }
                                    else
                                    {
                                        value = 0;
                                    }

                                }
                                else
                                {
                                    value = 0;
                                }
                            }
                            break;
                        case 2: // 0-正在采样(默认)  1-手动  2-定时  3-校准成功  4-校准失败  5-校准成功(正在采样)  6-校准失败(正在采样)
                            {
                                if (!SharedSpace.MControl.SetOut && !SharedSpace.MControl.SetRun)
                                {
                                    if ((ushort)SharedSpace.Data.typesint == 3)
                                        value = 5;
                                    else if ((ushort)SharedSpace.Data.typesint == 4)
                                        value = 6;
                                    else
                                        value = (ushort)SharedSpace.Data.typesint;
                                }
                                else
                                {
                                    value = (ushort)SharedSpace.Data.typesint;
                                }
                            }
                            break;
                        case 3:
                            {
                                value = SharedSpace.Data.change == true ? (ushort)1 : (ushort)0;
                            }
                            break;
                        case 4:
                            {
                                value = globaldata.m_hmibuffer.gcinfo.HMIMac[0];
                            }
                            break;
                        case 5:
                            {
                                value = globaldata.m_hmibuffer.gcinfo.HMIMac[1];
                            }
                            break;
                        case 6:
                            {
                                value = globaldata.m_hmibuffer.gcinfo.HMIMac[2];
                            }
                            break;
                        case 7: //设备联机状态
                            {
                                value = (ushort)(globaldata.m_hmibuffer.gcinfo.hmioffline ? 1 : 0);
                            }
                            break;
                        case 8: //HMI状态
                            {
                                value = globaldata.m_hmibuffer.gcinfo.methodstatus;
                            }
                            break;
                        case 9: //前进样口
                            {
                                if (CProfileDevice.m_DevParam.syspara.u16InjPortFront == 1)
                                {
                                    value = (ushort)(globaldata.m_dpbuffer.ShowList.showtemp.FPActualTemp * 10);
                                }
                                else
                                {
                                    value = 0;
                                }
                            }
                            break;
                        case 10: //后进样口
                            {
                                if (CProfileDevice.m_DevParam.syspara.u16InjPortBehind == 1)
                                {
                                    value = (ushort)(globaldata.m_dpbuffer.ShowList.showtemp.BPActualTemp * 10);
                                }
                                else
                                {
                                    value = 0;
                                }
                            }
                            break;
                        case 11: // 柱箱
                            {
                                if (CProfileDevice.m_DevParam.syspara.u16Col == 1)
                                {
                                    value = (ushort)(globaldata.m_dpbuffer.ShowList.showtemp.ColActualTemp * 10);
                                }
                                else
                                {
                                    value = 0;
                                }
                            }
                            break;
                        case 12: //前检测器
                            {
                                if (CProfileDevice.m_DevParam.syspara.u16InjPortFront == 1)
                                {
                                    if (CProfileDevice.m_DevParam.syspara.u16DetFrontType == 0)
                                    {
                                        value = (ushort)(globaldata.m_dpbuffer.ShowList.showtemp.fDetActualTemp * 10);
                                    }
                                    else if (CProfileDevice.m_DevParam.syspara.u16DetFrontType == 1)
                                    {
                                        value = (ushort)(globaldata.m_dpbuffer.ShowList.showtemp.fDetActualTemp * 10);
                                    }
                                    else
                                    {
                                        value = 0;
                                    }
                                }
                                else
                                {
                                    value = 0;
                                }
                            }
                            break;
                        case 13: //中检测器
                            {
                                if (CProfileDevice.m_DevParam.syspara.u16DetInter == 1)
                                {
                                    if (CProfileDevice.m_DevParam.syspara.u16DetInterType == 0)
                                    {
                                        value = (ushort)(globaldata.m_dpbuffer.ShowList.showtemp.iDetActualTemp * 10);
                                    }
                                    else if (CProfileDevice.m_DevParam.syspara.u16DetInterType == 1)
                                    {
                                        value = (ushort)(globaldata.m_dpbuffer.ShowList.showtemp.iDetActualTemp * 10);
                                    }
                                    else
                                    {
                                        value = 0;
                                    }
                                }
                                else if (CProfileDevice.m_DevParam.syspara.u16AuxHeater1 == 1)
                                {
                                    value = (ushort)(globaldata.m_dpbuffer.ShowList.showtemp.AuxActualTemp1 * 10);
                                }
                                else
                                {
                                    value = 0;
                                }
                            }
                            break;
                        case 14: //后检测器
                            {
                                if (CProfileDevice.m_DevParam.syspara.u16DetBehind == 1)
                                {
                                    if (CProfileDevice.m_DevParam.syspara.u16DetBehindType == 0)
                                    {
                                        value = (ushort)(globaldata.m_dpbuffer.ShowList.showtemp.bDetActualTemp * 10);
                                    }
                                    else if (CProfileDevice.m_DevParam.syspara.u16DetBehindType == 1)
                                    {
                                        value = (ushort)(globaldata.m_dpbuffer.ShowList.showtemp.bDetActualTemp * 10);
                                    }
                                    else if (CProfileDevice.m_DevParam.syspara.u16AuxHeater2 == 1)
                                    {
                                        value = (ushort)(globaldata.m_dpbuffer.ShowList.showtemp.AuxActualTemp2 * 10);
                                    }
                                    else
                                    {
                                        value = 0;
                                    }
                                }
                                else
                                {
                                    value = 0;
                                }
                            }
                            break;
                        case 15: //前点火信号
                            {
                                if (CProfileDevice.m_DevParam.syspara.u16DetFrontType == 1)
                                {
                                    value = globaldata.m_dpbuffer.ShowList.showDet.fDetStatue;
                                }
                                else
                                {
                                    value = 0;
                                }
                            }
                            break;
                        case 16: //后点火信号
                            {
                                if (CProfileDevice.m_DevParam.syspara.u16DetInterType == 1)
                                {
                                    value = globaldata.m_dpbuffer.ShowList.showDet.fDetStatue;
                                }
                                else
                                {
                                    value = 0;
                                }
                            }
                            break;
                    }
                }
                return value;
            }
            catch (Exception e)
            {
                Console.WriteLine("异常" + e.Message);
                return 0;
            }

        }

        static void slavewirtehreg(ushort address, ushort value)
        {
            if (address == 100 || address == 99 || address == 101)
            {
                if (value == 1)
                {
                    CurveDisPlay.curdisp.SetAutoAdjust();
                }
                else if (value == 0)
                {
                    CurveDisPlay.curdisp.StopAutoAdjust();
                }
            }

            Log.Info("MoudbusSlave Wirte adder:" + address.ToString() + " value:" + value.ToString());
        }

        public static ushort slavereadcreg(ushort address)
        {

            ushort value = 0;
            switch (address)
            {
                case 16:
                    value = globaldata.m_hmibuffer.gcinfo.TenRelay[0];
                    break;
                case 17:
                    value = globaldata.m_hmibuffer.gcinfo.TenRelay[1];
                    break;
                case 18:
                    value = globaldata.m_hmibuffer.gcinfo.TenRelay[2];
                    break;
                case 19:
                    value = globaldata.m_hmibuffer.gcinfo.TenRelay[3];
                    break;
                case 20:
                    value = globaldata.m_hmibuffer.gcinfo.TenRelay[4];
                    break;
                case 21:
                    value = globaldata.m_hmibuffer.gcinfo.TenRelay[5];
                    break;
                case 22:
                    value = globaldata.m_hmibuffer.gcinfo.TenRelay[6];
                    break;
                case 23:
                    value = globaldata.m_hmibuffer.gcinfo.TenRelay[7];
                    break;
                case 24:
                    value = globaldata.m_hmibuffer.gcinfo.TenRelay[8];
                    break;
                case 25:
                    value = globaldata.m_hmibuffer.gcinfo.TenRelay[9];
                    break;
                default:
                    value = 0;
                    break;
            }
            //   Console.WriteLine("MoudbusSlave Read Holding adder is " + CKVocAnalyzer.GlobalCKV.valueparamlist.ToString());
            return value;


        }
    }

}
